###############################################################################
# Generate sample data
from sklearn.svm import SVR,NuSVR
import numpy as np
import mdp,fileinput,json,urllib,urllib2,operator,sys
import random,numpy,ols,json
from sklearn.decomposition import PCA
from numpy import genfromtxt


name=[]
for usr in fileinput.input(['usernames.txt']):
        name.append(usr)
usr_domain={}
for line in fileinput.input(['user_domain.txt']):
         t= line.split(",")
	 usr_domain[t[0]] = t[1]
	
result={}
med_usr={}
for line in fileinput.input(['median.txt']):
        t = line.split(',')
        med_usr[t[0]]= float(t[1].rstrip())

row = numpy.zeros(11)
sample_tweet = sys.argv[1]
print "test tweet: " + str(sample_tweet)
url_string = 'http://uclassify.com/browse/uClassify/Topics/ClassifyText?readkey=H9w6mR8Vd9SVofmmKgAdNVuF0Ew&'
tweetText ={'text' :'beer is good' }
tweetText['text']=sample_tweet
url_string += urllib.urlencode(tweetText)
url_string += '&output=json&version=1.01'
f = urllib2.urlopen(url_string)
ob = json.loads(f.read())
out=''
m=0
non_zero=[]
for key,value in  ob['cls1'].iteritems():
	row[m]=value
	if value < 0.01 :
		row[m]=0
	else:
		non_zero.append(m)	
	m+=1
#print non_zero


for usr in name:
	fname = usr.rstrip() + "_records.txt"
	#print "user: " + usr 
	
	my_data = genfromtxt(fname, delimiter=",")
	rec_len= my_data.shape[0]
	
	#temp = my_data[0:150,25]
	#a = my_data[0:170,1:11]
	#b = my_data[0:170,25]

	modelx = numpy.array((my_data[:,1:11]))
        a = my_data[:,1:11]
        b = my_data[:,15]
	srtd=sorted(b)
	mid = len(b)/2
	if len(b) % 2 == 0:  # take the avg of middle two
        	med= (srtd[mid-1] + srtd[mid]) / 2.0
    	else:
        	med= srtd[mid]  
	#print med
        #print a.shape
        #print b.shape
        temp= b.shape[0]
        b.ravel()
        b.shape = (1,temp)
        t=b.transpose()

        x = numpy.concatenate((a,t),axis=1)
	#print x.shape
        #print "tweets: " + str(x.shape[0]) 
        b = my_data[:,14]
        temp= b.shape[0]
        b.ravel()
        b.shape = (1,temp)
        y=b.transpose()
	#print y.shape

	population = range(rec_len) # Your number of rows
	total = 0
	rel_tweet_cnt=0
	for c in range(rec_len):
		flag=0
		for j in range(len(non_zero)):
			if my_data[c,j] > 0 :
				flag=1
				total+=my_data[c,10]*my_data[c,j]
		if flag==1:
			rel_tweet_cnt +=1	
	total = total * rel_tweet_cnt/rec_len
	#print "total" + str(total)	
	choice = random.sample(population, rec_len) # arg 2 being the number of samples you require
	#print choice[0:int(len(choice)*0.10)]
	#print x[choice*0.10]
	#print int(0.1*len(choice))
	modelx = numpy.array(x[choice[int(0.1*len(choice))],])
	modely = y[choice[int(0.1*len(choice))],]
	for i in range(int(0.1*len(choice))+1,len(choice)):
        	#modelx = numpy.vstack((modelx,x[choice[i]]))
        	modelx = numpy.concatenate((modelx,x[choice[i],]),axis=0)
        	#modely = numpy.vstack((modely,y[choice[i]]))
        	modely = numpy.concatenate((modely,y[choice[i],]),axis=0)

	testx = x[choice[0],]
	testy = y[choice[0],]
	for i in range(1,int(0.1*len(choice))):
        	#testx = numpy.vstack((testx,x[choice[i]]))
        	testx = numpy.concatenate((testx,x[choice[i]]),axis=0)
        	#testy = numpy.vstack((testy,y[choice[i]]))
        	testy = numpy.concatenate((testy,y[choice[i]]),axis=0)

	#print testx.shape
	#print testy.shape
	#print modelx.shape
	#print modely.shape
	x1 =[]
	t=0
	#for k in modelx:
	#	
	#	u=0
	#	for j in k:
	#		x1[t,u]=j
	#		u+=1
	#	t+=1
		
	#print x1
	
	boundary=int(0.9*rec_len)
	modelx = x[:boundary,:]
	modely = y[:boundary,0]
	testx=x[boundary:,:]
	testy=y[boundary:,0]
	## Fit regression model
#
	svr_rbf = SVR(kernel='rbf', C=1e3, gamma=0.2)
	#print modelx
	#print modely
	ob_rbf = svr_rbf.fit(modelx,modely).predict(testx)
	#print modely
	#print "test set tweets: " + str(testx.shape[0])
	#print "actual"
	#print ",".join(["%0.1f" % i for i in testy])
	#print "predicted"
	#print ",".join(["%0.1f" % i for i in ob_rbf])
	#print "**************************************************************"
	
	row = numpy.zeros(11)
	sample_tweet = "Apple makes the best computers"
	url_string = 'http://uclassify.com/browse/uClassify/Topics/ClassifyText?readkey=H9w6mR8Vd9SVofmmKgAdNVuF0Ew&'
	tweetText ={'text' :'beer is good' }
	tweetText['text']=sample_tweet
	url_string += urllib.urlencode(tweetText)
	url_string += '&output=json&version=1.01'
	f = urllib2.urlopen(url_string)
	ob = json.loads(f.read())
	out=''
	m=0
	for key,value in  ob['cls1'].iteritems():
	       row[m]=value
	       if value < 0.01 :
	               row[m]=0
	       m+=1
	
	row[10]=med_usr[usr.rstrip()]
	row[10]=total
	modelx = x
	modely= y[:,0]
	testx=row
	ob_rbf = svr_rbf.fit(modelx,modely).predict(testx)
	if ob_rbf < 0:
		continue
	#print ob_rbf
	result[usr.rstrip()]=ob_rbf
	#print row


#print sorted(result.iteritems(),key=operator.itemgetter(1),reverse=True)
res = sorted(result.iteritems(),key=operator.itemgetter(1),reverse=True)
for item in res:
	print item[0]+","+usr_domain[item[0]].rstrip()+","+str(int(item[1][0]))


